<!doctype html>
<html class="no-js" lang="">
    <head>
        <meta charset="utf-8">
        <meta http-equiv="x-ua-compatible" content="ie=edge">
        <title>frontend documentation</title>
        <meta name="description" content="">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <link rel="icon" type="image/x-icon" href="../images/favicon.ico">
	      <link rel="stylesheet" href="../styles/style.css">
    </head>
    <body>

        <div class="navbar navbar-default navbar-fixed-top visible-xs">
            <a href="../" class="navbar-brand">frontend documentation</a>
            <button type="button" class="btn btn-default btn-menu ion-ios-menu" id="btn-menu"></button>
        </div>

        <div class="xs-menu menu" id="mobile-menu">
                <div id="book-search-input" role="search"><input type="text" placeholder="Type to search"></div>            <compodoc-menu></compodoc-menu>
        </div>

        <div class="container-fluid main">
           <div class="row main">
               <div class="hidden-xs menu">
                   <compodoc-menu mode="normal"></compodoc-menu>
               </div>
               <!-- START CONTENT -->
               <div class="content injectable">
                   <div class="content-data">







<ol class="breadcrumb">
  <li>Injectables</li>
  <li>ProtocolService</li>
</ol>

<ul class="nav nav-tabs" role="tablist">
        <li class="active">
            <a href="#info" role="tab" id="info-tab" data-toggle="tab" data-link="info">Info</a>
        </li>
        <li >
            <a href="#source" role="tab" id="source-tab" data-toggle="tab" data-link="source">Source</a>
        </li>
</ul>

<div class="tab-content">
    <div class="tab-pane fade active in" id="c-info">
        <p class="comment">
            <h3>File</h3>
        </p>
        <p class="comment">
            <code>src/app/core/service/protocol.service.ts</code>
        </p>



            <section>
    <h3 id="index">Index</h3>
    <table class="table table-sm table-bordered index-table">
        <tbody>
                <tr>
                    <td class="col-md-4">
                        <h6><b>Properties</b></h6>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <ul class="index-list">
                            <li>
                                    <span class="modifier">Private</span>
                                <a href="#_finalizationCode">_finalizationCode</a>
                            </li>
                            <li>
                                    <span class="modifier">Private</span>
                                <a href="#_identificationCredentials">_identificationCredentials</a>
                            </li>
                            <li>
                                    <span class="modifier">Private</span>
                                <a href="#_protocolId">_protocolId</a>
                            </li>
                            <li>
                                    <span class="modifier">Private</span>
                                <a href="#_voterId">_voterId</a>
                            </li>
                            <li>
                                    <span class="modifier">Private</span>
                                <a href="#obliviousTransferResponses">obliviousTransferResponses</a>
                            </li>
                            <li>
                                    <span class="modifier">Private</span>
                                <a href="#pointMatrix">pointMatrix</a>
                            </li>
                            <li>
                                    <span class="modifier">Private</span>
                                <a href="#publicKeyParts">publicKeyParts</a>
                            </li>
                            <li>
                                    <span class="modifier">Private</span>
                                <a href="#randomizations">randomizations</a>
                            </li>
                            <li>
                                    <span class="modifier">Private</span>
                                <a href="#selections">selections</a>
                            </li>
                            <li>
                                    <span class="modifier">Private</span>
                                <a href="#serviceUrl">serviceUrl</a>
                            </li>
                            <li>
                                    <span class="modifier">Private</span>
                                <a href="#voteCasting">voteCasting</a>
                            </li>
                            <li>
                                    <span class="modifier">Private</span>
                                <a href="#voteConfirmation">voteConfirmation</a>
                            </li>
                        </ul>
                    </td>
                </tr>

                <tr>
                    <td class="col-md-4">
                        <h6><b>Methods</b></h6>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <ul class="index-list">
                            <li>
                                    <span class="modifier">Private</span>
                                <a href="#getPrimes">getPrimes</a>
                            </li>
                            <li>
                                    <span class="modifier">Private</span>
                                <a href="#getPublicKeys">getPublicKeys</a>
                            </li>
                            <li>
                                    <span class="modifier">Private</span>
                                <a href="#getPublicParameters">getPublicParameters</a>
                            </li>
                            <li>
                                    <span class="modifier">Public</span>
                                <a href="#initialize">initialize</a>
                            </li>
                            <li>
                                    <span class="modifier">Public</span>
                                <a href="#retrieveVerificationCodes">retrieveVerificationCodes</a>
                            </li>
                            <li>
                                    <span class="modifier">Public</span>
                                <a href="#submitBallot">submitBallot</a>
                            </li>
                            <li>
                                    <span class="modifier">Public</span>
                                <a href="#submitConfirmationCode">submitConfirmationCode</a>
                            </li>
                        </ul>
                    </td>
                </tr>





                    <tr>
                        <td class="col-md-4">
                            <h6><b>Accessors</b></h6>
                        </td>
                    </tr>
                    <tr>
                        <td class="col-md-4">
                            <ul class="index-list">
                                <li>
                                    <a href="#identificationCredentials">identificationCredentials</a>
                                </li>
                                <li>
                                    <a href="#voterId">voterId</a>
                                </li>
                                <li>
                                    <a href="#protocolId">protocolId</a>
                                </li>
                                <li>
                                    <a href="#finalizationCode">finalizationCode</a>
                                </li>
                            </ul>
                        </td>
                    </tr>
        </tbody>
    </table>
</section>

            <section>
    <h3 id="constructor">Constructor</h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
<code>constructor(http: <a href="https://angular.io/api/common/http/HttpClient" target="_blank">HttpClient</a>, httpParameters: <a href="../injectables/HttpParameters.html">HttpParameters</a>, blake2bService: Blake2bService, currentVotingService: <a href="../injectables/CurrentVotingService.html">CurrentVotingService</a>)</code>
                    </td>
                </tr>
                        <tr>
                            <td class="col-md-4">
                                <div class="io-line">Defined in <a href="" data-line="56" class="link-to-prism">src/app/core/service/protocol.service.ts:56</a></div>
                            </td>
                        </tr>

                <tr>
                    <td class="col-md-4">
                            <div>
                                    <b>Parameters :</b>
                                    <table class="params">
                                        <thead>
                                            <tr>
                                                <td>Name</td>
                                                    <td>Type</td>
                                                <td>Optional</td>
                                            </tr>
                                        </thead>
                                        <tbody>
                                                <tr>
                                                        <td>http</td>
                                                  
                                                        <td>
                                                                    <code><a href="https://angular.io/api/common/http/HttpClient" target="_blank" >HttpClient</a></code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                                <tr>
                                                        <td>httpParameters</td>
                                                  
                                                        <td>
                                                                    <code><a href="../injectables/HttpParameters.html" target="_self" >HttpParameters</a></code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                                <tr>
                                                        <td>blake2bService</td>
                                                  
                                                        <td>
                                                                    <code>Blake2bService</code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                                <tr>
                                                        <td>currentVotingService</td>
                                                  
                                                        <td>
                                                                    <code><a href="../injectables/CurrentVotingService.html" target="_self" >CurrentVotingService</a></code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                        </tbody>
                                    </table>
                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
</section>

            <section>
    
        <h3 id="methods">
            Methods
        </h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="getPrimes"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Private</span>
                            getPrimes
                            </b>
                            <a href="#getPrimes"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                            <span class="modifier-icon icon ion-ios-reset"></span>
                        <code>getPrimes(protocolId: <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank">string</a>)</code>
                    </td>
                </tr>


                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="167" class="link-to-prism">src/app/core/service/protocol.service.ts:167</a></div>
                            </td>
                        </tr>


                <tr>
                    <td class="col-md-4">

                            <div class="io-description">
                                    <b>Parameters :</b>
                                    <table class="params">
                                        <thead>
                                            <tr>
                                                <td>Name</td>
                                                    <td>Type</td>
                                                <td>Optional</td>
                                            </tr>
                                        </thead>
                                        <tbody>
                                                <tr>
                                                        <td>protocolId</td>
                                                        <td>
                                                                    <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
                                                        </td>
                                                    
                                                    <td>
                                                            No
                                                    </td>
                                                    

                                                </tr>
                                        </tbody>
                                    </table>
                            </div>
                            <div>
                            </div>
                            <div class="io-description">
                                <b>Returns : </b>    <code>Observable&lt;BigInteger[]&gt;</code>

                            </div>
                                <div class="io-description">
                                    
                                </div>
                    </td>
                </tr>
            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="getPublicKeys"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Private</span>
                            getPublicKeys
                            </b>
                            <a href="#getPublicKeys"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                            <span class="modifier-icon icon ion-ios-reset"></span>
                        <code>getPublicKeys(protocolId: <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank">string</a>)</code>
                    </td>
                </tr>


                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="175" class="link-to-prism">src/app/core/service/protocol.service.ts:175</a></div>
                            </td>
                        </tr>


                <tr>
                    <td class="col-md-4">

                            <div class="io-description">
                                    <b>Parameters :</b>
                                    <table class="params">
                                        <thead>
                                            <tr>
                                                <td>Name</td>
                                                    <td>Type</td>
                                                <td>Optional</td>
                                            </tr>
                                        </thead>
                                        <tbody>
                                                <tr>
                                                        <td>protocolId</td>
                                                        <td>
                                                                    <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
                                                        </td>
                                                    
                                                    <td>
                                                            No
                                                    </td>
                                                    

                                                </tr>
                                        </tbody>
                                    </table>
                            </div>
                            <div>
                            </div>
                            <div class="io-description">
                                <b>Returns : </b>    <code>Observable&lt;EncryptionPublicKey[]&gt;</code>

                            </div>
                                <div class="io-description">
                                    
                                </div>
                    </td>
                </tr>
            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="getPublicParameters"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Private</span>
                            getPublicParameters
                            </b>
                            <a href="#getPublicParameters"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                            <span class="modifier-icon icon ion-ios-reset"></span>
                        <code>getPublicParameters(protocolId: <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank">string</a>)</code>
                    </td>
                </tr>


                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="161" class="link-to-prism">src/app/core/service/protocol.service.ts:161</a></div>
                            </td>
                        </tr>


                <tr>
                    <td class="col-md-4">

                            <div class="io-description">
                                    <b>Parameters :</b>
                                    <table class="params">
                                        <thead>
                                            <tr>
                                                <td>Name</td>
                                                    <td>Type</td>
                                                <td>Optional</td>
                                            </tr>
                                        </thead>
                                        <tbody>
                                                <tr>
                                                        <td>protocolId</td>
                                                        <td>
                                                                    <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
                                                        </td>
                                                    
                                                    <td>
                                                            No
                                                    </td>
                                                    

                                                </tr>
                                        </tbody>
                                    </table>
                            </div>
                            <div>
                            </div>
                            <div class="io-description">
                                <b>Returns : </b>    <code>Observable&lt;PublicParameters&gt;</code>

                            </div>
                                <div class="io-description">
                                    
                                </div>
                    </td>
                </tr>
            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="initialize"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Public</span>
                            initialize
                            </b>
                            <a href="#initialize"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                            <span class="modifier-icon icon ion-ios-reset"></span>
                        <code>initialize(protocolId: <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank">string</a>)</code>
                    </td>
                </tr>


                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="81" class="link-to-prism">src/app/core/service/protocol.service.ts:81</a></div>
                            </td>
                        </tr>


                <tr>
                    <td class="col-md-4">

                            <div class="io-description">
                                    <b>Parameters :</b>
                                    <table class="params">
                                        <thead>
                                            <tr>
                                                <td>Name</td>
                                                    <td>Type</td>
                                                <td>Optional</td>
                                            </tr>
                                        </thead>
                                        <tbody>
                                                <tr>
                                                        <td>protocolId</td>
                                                        <td>
                                                                    <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
                                                        </td>
                                                    
                                                    <td>
                                                            No
                                                    </td>
                                                    

                                                </tr>
                                        </tbody>
                                    </table>
                            </div>
                            <div>
                            </div>
                            <div class="io-description">
                                <b>Returns : </b>    <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                            </div>
                                <div class="io-description">
                                    
                                </div>
                    </td>
                </tr>
            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="retrieveVerificationCodes"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Public</span>
                            retrieveVerificationCodes
                            </b>
                            <a href="#retrieveVerificationCodes"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                            <span class="modifier-icon icon ion-ios-reset"></span>
                        <code>retrieveVerificationCodes()</code>
                    </td>
                </tr>


                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="126" class="link-to-prism">src/app/core/service/protocol.service.ts:126</a></div>
                            </td>
                        </tr>


                <tr>
                    <td class="col-md-4">

                            <div class="io-description">
                                <b>Returns : </b>    <code>string[]</code>

                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="submitBallot"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Public</span>
                            submitBallot
                            </b>
                            <a href="#submitBallot"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                            <span class="modifier-icon icon ion-ios-reset"></span>
                        <code>submitBallot(birthDate)</code>
                    </td>
                </tr>


                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="101" class="link-to-prism">src/app/core/service/protocol.service.ts:101</a></div>
                            </td>
                        </tr>


                <tr>
                    <td class="col-md-4">

                            <div class="io-description">
                                    <b>Parameters :</b>
                                    <table class="params">
                                        <thead>
                                            <tr>
                                                <td>Name</td>
                                                <td>Optional</td>
                                            </tr>
                                        </thead>
                                        <tbody>
                                                <tr>
                                                        <td>birthDate</td>
                                                    
                                                    <td>
                                                            No
                                                    </td>
                                                    

                                                </tr>
                                        </tbody>
                                    </table>
                            </div>
                            <div>
                            </div>
                            <div class="io-description">
                                <b>Returns : </b>    <code>Observable&lt;void&gt;</code>

                            </div>
                                <div class="io-description">
                                    
                                </div>
                    </td>
                </tr>
            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="submitConfirmationCode"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Public</span>
                            submitConfirmationCode
                            </b>
                            <a href="#submitConfirmationCode"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                            <span class="modifier-icon icon ion-ios-reset"></span>
                        <code>submitConfirmationCode(confirmationCredentials: <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank">string</a>)</code>
                    </td>
                </tr>


                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="140" class="link-to-prism">src/app/core/service/protocol.service.ts:140</a></div>
                            </td>
                        </tr>


                <tr>
                    <td class="col-md-4">

                            <div class="io-description">
                                    <b>Parameters :</b>
                                    <table class="params">
                                        <thead>
                                            <tr>
                                                <td>Name</td>
                                                    <td>Type</td>
                                                <td>Optional</td>
                                            </tr>
                                        </thead>
                                        <tbody>
                                                <tr>
                                                        <td>confirmationCredentials</td>
                                                        <td>
                                                                    <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
                                                        </td>
                                                    
                                                    <td>
                                                            No
                                                    </td>
                                                    

                                                </tr>
                                        </tbody>
                                    </table>
                            </div>
                            <div>
                            </div>
                            <div class="io-description">
                                <b>Returns : </b>    <code>Observable&lt;void&gt;</code>

                            </div>
                                <div class="io-description">
                                    
                                </div>
                    </td>
                </tr>
            </tbody>
        </table>
</section>

            <section>
    
        <h3 id="inputs">
            Properties
        </h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="_finalizationCode"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Private</span>
                            _finalizationCode
                            </b>
                            <a href="#_finalizationCode"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <span class="modifier-icon icon ion-ios-reset"></span><code>_finalizationCode:     <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
</code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Type : </i>    <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>

                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="51" class="link-to-prism">src/app/core/service/protocol.service.ts:51</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="_identificationCredentials"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Private</span>
                            _identificationCredentials
                            </b>
                            <a href="#_identificationCredentials"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <span class="modifier-icon icon ion-ios-reset"></span><code>_identificationCredentials:     <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
</code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Type : </i>    <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>

                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="49" class="link-to-prism">src/app/core/service/protocol.service.ts:49</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="_protocolId"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Private</span>
                            _protocolId
                            </b>
                            <a href="#_protocolId"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <span class="modifier-icon icon ion-ios-reset"></span><code>_protocolId:     <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
</code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Type : </i>    <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>

                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="48" class="link-to-prism">src/app/core/service/protocol.service.ts:48</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="_voterId"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Private</span>
                            _voterId
                            </b>
                            <a href="#_voterId"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <span class="modifier-icon icon ion-ios-reset"></span><code>_voterId:     <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
</code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Type : </i>    <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>

                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="50" class="link-to-prism">src/app/core/service/protocol.service.ts:50</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="obliviousTransferResponses"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Private</span>
                            obliviousTransferResponses
                            </b>
                            <a href="#obliviousTransferResponses"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <span class="modifier-icon icon ion-ios-reset"></span><code>obliviousTransferResponses:     <code>ObliviousTransferResponse[]</code>
</code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Type : </i>    <code>ObliviousTransferResponse[]</code>

                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="56" class="link-to-prism">src/app/core/service/protocol.service.ts:56</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="pointMatrix"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Private</span>
                            pointMatrix
                            </b>
                            <a href="#pointMatrix"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <span class="modifier-icon icon ion-ios-reset"></span><code>pointMatrix:     <code>Point[][]</code>
</code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Type : </i>    <code>Point[][]</code>

                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="55" class="link-to-prism">src/app/core/service/protocol.service.ts:55</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="publicKeyParts"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Private</span>
                            publicKeyParts
                            </b>
                            <a href="#publicKeyParts"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <span class="modifier-icon icon ion-ios-reset"></span><code>publicKeyParts:     <code>EncryptionPublicKey[]</code>
</code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Type : </i>    <code>EncryptionPublicKey[]</code>

                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="46" class="link-to-prism">src/app/core/service/protocol.service.ts:46</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="randomizations"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Private</span>
                            randomizations
                            </b>
                            <a href="#randomizations"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <span class="modifier-icon icon ion-ios-reset"></span><code>randomizations:     <code>BigInteger[]</code>
</code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Type : </i>    <code>BigInteger[]</code>

                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="54" class="link-to-prism">src/app/core/service/protocol.service.ts:54</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="selections"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Private</span>
                            selections
                            </b>
                            <a href="#selections"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <span class="modifier-icon icon ion-ios-reset"></span><code>selections:     <code>number[]</code>
</code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Type : </i>    <code>number[]</code>

                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="53" class="link-to-prism">src/app/core/service/protocol.service.ts:53</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="serviceUrl"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Private</span>
                            serviceUrl
                            </b>
                            <a href="#serviceUrl"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <span class="modifier-icon icon ion-ios-reset"></span><code>serviceUrl:     <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
</code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Type : </i>    <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>

                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="43" class="link-to-prism">src/app/core/service/protocol.service.ts:43</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="voteCasting"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Private</span>
                            voteCasting
                            </b>
                            <a href="#voteCasting"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <span class="modifier-icon icon ion-ios-reset"></span><code>voteCasting:     <code>VoteCasting</code>
</code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Type : </i>    <code>VoteCasting</code>

                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="44" class="link-to-prism">src/app/core/service/protocol.service.ts:44</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="voteConfirmation"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Private</span>
                            voteConfirmation
                            </b>
                            <a href="#voteConfirmation"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <span class="modifier-icon icon ion-ios-reset"></span><code>voteConfirmation:     <code>VoteConfirmation</code>
</code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Type : </i>    <code>VoteConfirmation</code>

                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="45" class="link-to-prism">src/app/core/service/protocol.service.ts:45</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
</section>

            <section>
    <h3 id="accessors">
        Accessors
    </h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="identificationCredentials"></a>
                        <span class="name"><b>identificationCredentials</b><a href="#identificationCredentials"><span class="icon ion-ios-link"></span></a></span>
                    </td>
                </tr>


                <tr>
                    <td class="col-md-4">
                        <span class="accessor"><b>set</b><code>identificationCredentials(value: <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank">string</a>)</code></span>
                    </td>
                </tr>
                            <tr>
                                <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="65" class="link-to-prism">src/app/core/service/protocol.service.ts:65</a></div>
                                </td>
                            </tr>
                    <tr>
                        <td class="col-md-4">

                                <div class="io-description">
                                        <b>Parameters :</b>
                                        <table class="params">
                                            <thead>
                                                <tr>
                                                    <td>Name</td>
                                                        <td>Type</td>
                                                    <td>Optional</td>
                                                </tr>
                                            </thead>
                                            <tbody>
                                                    <tr>
                                                            <td>value</td>
                                                    
                                                            <td>
                                                                        <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
                                                            </td>
                                                    
                                                        <td>
                                                                No
                                                        </td>
                                                        
                                                    </tr>
                                            </tbody>
                                        </table>
                                </div>
                                <div>
                                </div>
                                <div class="io-description">
                                    <b>Returns : </b>    <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                                </div>
                        </td>
                    </tr>
            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="voterId"></a>
                        <span class="name"><b>voterId</b><a href="#voterId"><span class="icon ion-ios-link"></span></a></span>
                    </td>
                </tr>

                <tr>
                    <td class="col-md-4">
                        <span class="accessor"><b>get</b><code>voterId()</code></span>
                    </td>
                </tr>
                            <tr>
                                <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="77" class="link-to-prism">src/app/core/service/protocol.service.ts:77</a></div>
                                </td>
                            </tr>

                <tr>
                    <td class="col-md-4">
                        <span class="accessor"><b>set</b><code>voterId(value: <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank">string</a>)</code></span>
                    </td>
                </tr>
                            <tr>
                                <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="69" class="link-to-prism">src/app/core/service/protocol.service.ts:69</a></div>
                                </td>
                            </tr>
                    <tr>
                        <td class="col-md-4">

                                <div class="io-description">
                                        <b>Parameters :</b>
                                        <table class="params">
                                            <thead>
                                                <tr>
                                                    <td>Name</td>
                                                        <td>Type</td>
                                                    <td>Optional</td>
                                                </tr>
                                            </thead>
                                            <tbody>
                                                    <tr>
                                                            <td>value</td>
                                                    
                                                            <td>
                                                                        <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
                                                            </td>
                                                    
                                                        <td>
                                                                No
                                                        </td>
                                                        
                                                    </tr>
                                            </tbody>
                                        </table>
                                </div>
                                <div>
                                </div>
                                <div class="io-description">
                                    <b>Returns : </b>    <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                                </div>
                        </td>
                    </tr>
            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="protocolId"></a>
                        <span class="name"><b>protocolId</b><a href="#protocolId"><span class="icon ion-ios-link"></span></a></span>
                    </td>
                </tr>

                <tr>
                    <td class="col-md-4">
                        <span class="accessor"><b>get</b><code>protocolId()</code></span>
                    </td>
                </tr>
                            <tr>
                                <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="73" class="link-to-prism">src/app/core/service/protocol.service.ts:73</a></div>
                                </td>
                            </tr>

            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="finalizationCode"></a>
                        <span class="name"><b>finalizationCode</b><a href="#finalizationCode"><span class="icon ion-ios-link"></span></a></span>
                    </td>
                </tr>

                <tr>
                    <td class="col-md-4">
                        <span class="accessor"><b>get</b><code>finalizationCode()</code></span>
                    </td>
                </tr>
                            <tr>
                                <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="157" class="link-to-prism">src/app/core/service/protocol.service.ts:157</a></div>
                                </td>
                            </tr>

            </tbody>
        </table>
</section>
    </div>


    <div class="tab-pane fade  tab-source-code" id="c-source">
        <pre class="line-numbers compodoc-sourcecode"><code class="language-typescript">import { first, map } from &#x27;rxjs/operators&#x27;;
import { Injectable } from &#x27;@angular/core&#x27;;
import { forkJoin, Observable } from &#x27;rxjs&#x27;;
import { HttpClient } from &#x27;@angular/common/http&#x27;;
import {
  BallotQueryAndRand, BigInteger, Confirmation, EncryptionPublicKey, EncryptionPublicKeyJSON, FinalizationCodePart,
  FinalizationCodePartJSON, GeneralAlgorithms, Hash, KeyEstablishment, ObliviousTransferResponse,
  ObliviousTransferResponseJSON, Point, PrimesCache, PublicParameters, PublicParametersJSON, VoteCasting,
  VoteConfirmation
} from &#x27;chvote-protocol-client&#x27;;
import { HttpParameters } from &#x27;../http/http.parameters.service&#x27;;
import { Blake2bService } from &#x27;@protocoder/blake2&#x27;;
import &#x27;rxjs/Rx&#x27;;
import * as _ from &#x27;underscore&#x27;;
import { CurrentVotingService } from &#x27;../../operation/current-voting-service&#x27;;

@Injectable()
export class ProtocolService {
  private serviceUrl: string;
  private voteCasting: VoteCasting;
  private voteConfirmation: VoteConfirmation;
  private publicKeyParts: EncryptionPublicKey[];

  private _protocolId: string;
  private _identificationCredentials: string;
  private _voterId: string;
  private _finalizationCode: string;

  private selections: number[];
  private randomizations: BigInteger[];
  private pointMatrix: Point[][];
  private obliviousTransferResponses: ObliviousTransferResponse[];

  constructor(private http: HttpClient,
              private httpParameters: HttpParameters,
              private blake2bService: Blake2bService,
              private currentVotingService: CurrentVotingService) {
    this.serviceUrl &#x3D; &#x60;${this.httpParameters.apiBaseURL}/protocol&#x60;;
  }

  set identificationCredentials(value: string) {
    this._identificationCredentials &#x3D; value;
  }

  set voterId(value: string) {
    this._voterId &#x3D; value;
  }

  get protocolId(): string {
    return this._protocolId;
  }

  get voterId(): string {
    return this._voterId;
  }

  public initialize(protocolId: string): void {
    this._protocolId &#x3D; protocolId;
    forkJoin(
      this.getPublicParameters(this._protocolId),
      this.getPublicKeys(this._protocolId),
      this.getPrimes(this._protocolId)
    ).subscribe(results &#x3D;&gt; {
      let publicParameters: PublicParameters &#x3D; results[0] as PublicParameters;
      this.publicKeyParts &#x3D; results[1];

      let hash: Hash &#x3D; new Hash(this.blake2bService, publicParameters.securityParameters.upper_l);
      let primesCache: PrimesCache &#x3D; new PrimesCache(results[2] as BigInteger[], publicParameters.encryptionGroup);
      let generalAlgo: GeneralAlgorithms &#x3D; new GeneralAlgorithms(hash, publicParameters.encryptionGroup,
        publicParameters.identificationGroup, primesCache);

      this.voteCasting &#x3D; new VoteCasting(publicParameters, generalAlgo, hash);
      this.voteConfirmation &#x3D; new VoteConfirmation(publicParameters, generalAlgo);
    });
  }

  public submitBallot(birthDate): Observable&lt;void&gt; {
    // 1. compute voter&#x27;s selection
    this.selections &#x3D; this.currentVotingService.buildSelection();
    // 2. build system public key
    let systemPublicKey: EncryptionPublicKey &#x3D; KeyEstablishment.getPublicKey(this.publicKeyParts);
    // 3. encrypt ballot
    let ballotQueryAndRand: BallotQueryAndRand &#x3D;
      this.voteCasting.genBallot(this._identificationCredentials, this.selections, systemPublicKey);
    // 4. keep randomization for verification codes
    this.randomizations &#x3D; ballotQueryAndRand.bold_r;
    // 5. send encrypted ballot to server and keep oblivious transfer response
    return this.http.post&lt;ObliviousTransferResponseJSON[]&gt;(
      &#x60;${this.serviceUrl}/submit-ballot&#x60;,
      {
        birthDate,
        ballotAndQuery: ballotQueryAndRand.alpha.toJSON()
      }, {params: {protocolInstanceId: this._protocolId, voterId: this._voterId}}).pipe(
      map(responsesJSON &#x3D;&gt; {
        this.obliviousTransferResponses &#x3D; [];
        for (let response of responsesJSON) {
          this.obliviousTransferResponses.push(ObliviousTransferResponse.fromJSON(response));
        }
      }));
  }

  public retrieveVerificationCodes(): string[] {
    try {
      this.pointMatrix &#x3D; this.voteCasting.getPointMatrix(
        this.obliviousTransferResponses,
        this.selections,
        this.randomizations
      );
    }
    catch (error) {
      throw new Error(&#x60;Error while computing the point matrix: ${error.message}&#x60;);
    }
    return this.voteCasting.getReturnCodes(this.selections, this.pointMatrix);
  }

  public submitConfirmationCode(confirmationCredentials: string): Observable&lt;void&gt; {
    // 1. generate confirmation payload
    let confirmation: Confirmation &#x3D; this.voteConfirmation.genConfirmation(confirmationCredentials, this.pointMatrix);
    // 2. send confirmation to server
    return this.http.post&lt;FinalizationCodePartJSON[]&gt;(
      &#x60;${this.serviceUrl}/submit-confirmation-code&#x60;,
      confirmation.toJSON(), {params: {protocolInstanceId: this._protocolId, voterId: this._voterId}}
    ).pipe(map(responsesJSON &#x3D;&gt; {
      // 3. retrieve finalization code
      let finalizationCodeParts &#x3D; [];
      for (let response of responsesJSON) {
        finalizationCodeParts.push(FinalizationCodePart.fromJSON(response));
      }
      this._finalizationCode &#x3D; this.voteConfirmation.getFinalizationCode(finalizationCodeParts);
    }));
  }

  public get finalizationCode(): string {
    return this._finalizationCode;
  }

  private getPublicParameters(protocolId: string): Observable&lt;PublicParameters&gt; {
    return this.http.get&lt;PublicParametersJSON&gt;(&#x60;${this.serviceUrl}/public-parameters/&#x60;,
      {params: {protocolInstanceId: protocolId}}).pipe(first(),
      map(json &#x3D;&gt; PublicParameters.fromJSON(json)),);
  }

  private getPrimes(protocolId: string): Observable&lt;BigInteger[]&gt; {
    return this.http.get&lt;string[]&gt;(&#x60;${this.serviceUrl}/primes&#x60;, {params: {protocolInstanceId: protocolId}})
      .pipe(first(),
        map(primes &#x3D;&gt; _.map(primes, function (prime: string) {
          return new BigInteger(prime);
        })),);
  }

  private getPublicKeys(protocolId: string): Observable&lt;EncryptionPublicKey[]&gt; {
    return this.http.get&lt;EncryptionPublicKeyJSON[]&gt;(&#x60;${this.serviceUrl}/public-keys&#x60;,
      {params: {protocolInstanceId: protocolId}}).pipe(first(),
      map(keysJSON &#x3D;&gt; {
        let keys: EncryptionPublicKey[] &#x3D; [];
        for (let key of keysJSON) {
          keys.push(EncryptionPublicKey.fromJSON(key));
        }
        return keys;
      }),);
  }
}
</code></pre>
    </div>

</div>











                   </div><div class="search-results">
    <div class="has-results">
        <h1 class="search-results-title"><span class='search-results-count'></span> result-matching "<span class='search-query'></span>"</h1>
        <ul class="search-results-list"></ul>
    </div>
    <div class="no-results">
        <h1 class="search-results-title">No results matching "<span class='search-query'></span>"</h1>
    </div>
</div>
</div>
               <!-- END CONTENT -->
           </div>
       </div>

       <script>
            var COMPODOC_CURRENT_PAGE_DEPTH = 1;
            var COMPODOC_CURRENT_PAGE_CONTEXT = 'injectable';
            var COMPODOC_CURRENT_PAGE_URL = 'ProtocolService.html';
       </script>

       <script src="../js/libs/custom-elements.min.js"></script>
       <script src="../js/libs/lit-html.js"></script>
       <!-- Required to polyfill modern browsers as code is ES5 for IE... -->
       <script src="../js/libs/custom-elements-es5-adapter.js" charset="utf-8" defer></script>
       <script src="../js/menu-wc.js" defer></script>

       <script src="../js/libs/bootstrap-native.js"></script>

       <script src="../js/libs/es6-shim.min.js"></script>
       <script src="../js/libs/EventDispatcher.js"></script>
       <script src="../js/libs/promise.min.js"></script>
       <script src="../js/libs/zepto.min.js"></script>

       <script src="../js/compodoc.js"></script>

       <script src="../js/tabs.js"></script>
       <script src="../js/menu.js"></script>
       <script src="../js/libs/clipboard.min.js"></script>
       <script src="../js/libs/prism.js"></script>
       <script src="../js/sourceCode.js"></script>
          <script src="../js/search/search.js"></script>
          <script src="../js/search/lunr.min.js"></script>
          <script src="../js/search/search-lunr.js"></script>
          <script src="../js/search/search_index.js"></script>
       <script src="../js/lazy-load-graphs.js"></script>


    </body>
</html>
